<template>
  <div class="px-5 py-6">
    <el-form
      ref="ruleFormRef"
      :model="formData"
      status-icon
      :rules="getRule"
      :label-position="labelPosition"
      label-width="210px"
      :validate-on-rule-change="false"
    >
      <div
        v-if="
          paymentWithdrawalTextInfo?.Text?.length > 0 &&
          !$route.fullPath.includes('internetbanking')
        "
        class="pb-4 text-sm rounded font-normal mb-4 --text2 txt-info"
      >
        <span v-html="paymentWithdrawalTextInfo?.Text"></span>
      </div>
      <template v-if="isAupay">
        <el-form-item :label="$t('Pix Number')"
          prop="ExtraParameter.pixnumber"
          :rules="[
            {
              required: true,
              message: $t('required'),
              trigger: 'blur',
            },
          ]"
        >
          <el-input id="withdrawalPixNumber" v-model="formData.ExtraParameter.pixnumber"/>
        </el-form-item>
        <el-form-item :label="$t('Pix Type')"
          prop="ExtraParameter.pixtype"
          :rules="[
            {
              required: true,
              message: $t('required'),
              trigger: ['blur', 'change'],
            },
          ]"
        >
          <el-select v-model="formData.ExtraParameter.pixtype" class="w-full">
            <el-option
              v-for="item in pixTypeOptions"
              :key="item.value"
              :label="item.label"
              :value="item.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('name')"
          prop="ExtraParameter.name"
          :rules="[
            {
              required: true,
              message: $t('required'),
              trigger: 'blur',
            },
          ]"
        >
          <el-input id="withdrawalPixName" v-model="formData.ExtraParameter.name" />
        </el-form-item>
        <el-form-item :label="$t('CPF Number')"
          prop="ExtraParameter.cpfnumber"
          :rules="[
            {
              required: true,
              message: $t('required'),
              trigger: 'blur',
            },
          ]"
        >
          <el-input id="withdrawalCPFNumber" v-model="formData.ExtraParameter.cpfnumber" />
        </el-form-item>
      </template>
      <template v-else>
        <el-form-item
          v-if="isGlobalPayJPY"
          :label="$t('Branch Code')"
          prop="ExtraParameter.branchcode"
          :rules="[
            {
              required: true,
              message: $t('required'),
              trigger: 'blur',
            },
            {
              pattern: /^\d{3}$/,
              message: $t('must_be_3_digits_number'),
              trigger: 'blur',
            },
          ]"
        >
          <el-input id="branchcode" 
            v-model="formData.ExtraParameter.branchcode"
            oninput="this.value = this.value.replace(/[^.0-9]/g, '')"
          />
        </el-form-item>
        <el-form-item :label="$t('bank')">
          <el-select
            @visible-change="onVisibleChange"
            @change="onChangeSelect"
            @blur="onChangeSelect"
            v-model="selectedBank"
            class="w-full"
          >
            <el-option
              v-for="bank in bankRadios.radios"
              :key="bank"
              :label="bank.value"
              :value="bank.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('bank_account_name')" prop="bankAccountName">
          <el-input :disabled="isFillInPaymentBank === true && getPlayerBank !== undefined" v-model="formData.bankAccountName" />
        </el-form-item>
        <el-form-item :label="$t('bank_account_number')" prop="bankAccountNumber">
          <el-input
            v-un-focus
            :disabled="isFillInPaymentBank === true && getPlayerBank !== undefined"
            v-model="formData.bankAccountNumber"
            @input="onInputValue($event, formData, 'bankAccountNumber')"
          />
        </el-form-item>
      </template>
      <template v-if="isGtrpay">
        <el-form-item
          :label="$t('CPF Number')"
          prop="ExtraParameter.cpfnumber"
          :rules="[
            {
              required: true,
              message: $t('required'),
              trigger: 'blur',
            },
          ]"
        >
          <el-input
            id="withdrawalCPFNumber"
            v-model="formData.ExtraParameter.cpfnumber"
          />
        </el-form-item>
      </template>
      <el-form-item :label="$t('balance')" prop="balance">
        <span class="--text2">
          {{ playerCreditBalance }}
        </span>
      </el-form-item>
      <template v-if="isWithdrawalLimitEnabled">
        <el-form-item v-if="isAllowEligibleWithdrawal" :label="$t('eligible_withdrawal')">
          <div class="fc-primary font-bold">{{ eligibleWithdrawal }}</div>
        </el-form-item>
        <el-form-item prop="withdrawalLimit" :label="$t('remaining_rollover')">
          <span class="--text2">
            {{ remainingRollover }}
          </span>
        </el-form-item>
      </template>
      <el-form-item :label="$t('amount')" prop="amountValue">
        <el-input
          v-un-focus
          v-model="formData.amountValue"
          @input="onInputValue($event, formData, 'amountValue')"
          :placeholder="amountPlaceholder"
        >
          <template #append v-if="checkedCurrency">
            <span>000</span>
          </template>
        </el-input>
        <span v-if="checkedCurrency" class="order-1 text-xs fc-hint mt-3">{{
          $t(
            `withdrawal_amount_shown_by_the_system_${profile.Currency.toLowerCase()}`
          )
        }}</span>
      </el-form-item>
      <el-form-item
        :label="$t('payment_password')"
        v-if="isPaymentPasswordEnable"
        prop="paymentPassword"
      >
        <el-input
          v-un-focus
          type="password"
          v-model="formData.paymentPassword"
        ></el-input>
      </el-form-item>
      <el-form-item>
        <div
          v-if="
            internetBankingWithdrawalTextInfo.Text &&
            $route.fullPath.includes('internetbanking')
          "
          class="--text2"
        >
          <span v-html="internetBankingWithdrawalTextInfo.Text"></span>
        </div>
      </el-form-item>
    </el-form>
    <div class="text-center mt-10 submit-button-deposit">
      <el-button
        type="primary"
        round
        @click="submitWithdrawal(ruleFormRef)"
        :disabled="isWithdrawProcessing"
        >{{ $t("continue") }}</el-button
      >
    </div>
  </div>
</template>
<script lang="ts">
import { defineComponent, PropType, ref, toRefs } from "vue";
import { IGetPaymentGatewayBanksResponse } from "@/models/getPaymentGatewayBanksRespone";
import { ProfileDto } from "@/models/getProfileResponse";
import { usePaymentBankTransferWithdrawal } from "@/composables/payment/withdrawal/usePaymentBankTransferWithdrawal";
import commonHelper from "@/utils/commonHelper";

export default defineComponent({
  name: "MobilePaymentBankTransferWithdrawal",
  props: {
    paymentBanks: {
      type: Object as PropType<IGetPaymentGatewayBanksResponse>,
      required: true,
    },
    profile: {
      type: Object as PropType<ProfileDto>,
      required: true,
    },
    isPaymentPasswordEnable: {
      type: Boolean,
      default: false,
    },
    isWithdrawalLimitEnabled: {
      type: Boolean,
      default: false,
    },
  },
  setup(props) {
    const labelPosition = ref("top");
    const {
      paymentBanks,
      profile,
      isPaymentPasswordEnable,
      isWithdrawalLimitEnabled,
    } = toRefs(props);
    const {
      bankRadios,
      playerCreditBalance,
      selectedBank,
      withdrawalMin,
      withdrawalMax,
      submitWithdrawal,
      getRule,
      formData,
      ruleFormRef,
      isWithdrawProcessing,
      checkedCurrency,
      remainingRollover,
      eligibleWithdrawal,
      isDecimalAllow,
      amountPlaceholder,
      internetBankingWithdrawalTextInfo,
      paymentWithdrawalTextInfo,
      getPlayerBank,
      isFillInPaymentBank,
      isAupay,
      pixTypeOptions,
      isGtrpay,
      isGlobalPayJPY,
    } = usePaymentBankTransferWithdrawal(
      paymentBanks,
      profile,
      isPaymentPasswordEnable,
      isWithdrawalLimitEnabled
    );
    const { onChangeSelect, onVisibleChange, onInputValue, allowCompany, isAllowEligibleWithdrawal } = commonHelper;
    return {
      bankRadios,
      playerCreditBalance,
      selectedBank,
      withdrawalMin,
      withdrawalMax,
      submitWithdrawal,
      getRule,
      formData,
      ruleFormRef,
      isWithdrawProcessing,
      checkedCurrency,
      remainingRollover,
      eligibleWithdrawal,
      isDecimalAllow,
      labelPosition,
      amountPlaceholder,
      internetBankingWithdrawalTextInfo,
      onChangeSelect,
      onVisibleChange,
      paymentWithdrawalTextInfo,
      getPlayerBank,
      isFillInPaymentBank,
      isAupay,
      pixTypeOptions,
      onInputValue,
      allowCompany,
      isGtrpay,
      isAllowEligibleWithdrawal,
      isGlobalPayJPY,
    };
  },
});
</script>
<style scoped lang="scss">
[layout="peru"] {
  @media (max-width: 639px) {
    .txt-info {
        padding: 0;
      }
  }
}
</style>
